Custom field is rendered, even if its value is empty (for multiple)

2014-12-16 13:37 - Andriy Lesyuk

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version: 3.0.0   

Resolution: Fixed Affected version: 2.6.0

Description

Redmine checks, if the value is available for the custom field, as follows:

if custom_value.value.present?

 But for multiple custom fields (e.g., lists, that allow selecting multiple values), the original nil value is replaced with [nil] (not sure

where exactly). So, [nil].empty? returns false and the custom field gets rendered.

This issue affects 3.0.x and 1.4.x versions of Redmine.

P.S. Can be solved by montkey-patching `CustomFieldValue` as follows:

alias_method_chain :value, :extended

...

def value_with_extended

    value = value_without_extended

    if custom_field.multiple? && value.present? && value.size == 1 && value.first.nil?

        nil

    else

        value

    end

end

Related issues:

Related to Redmine - Defect #19482: Custom field (long text format) displayed... Closed

Associated revisions

Revision 13864 - 2015-01-10 14:03 - Jean-Philippe Lang

Fixed: Custom field is rendered, even if its value is empty (for multiple) (#18654).

History

#1 - 2014-12-21 21:35 - Jean-Philippe Lang

- Assignee set to Jean-Philippe Lang

- Target version set to 3.0.0

#2 - 2015-01-10 14:04 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Fixed

Fixed in r13864, thanks for pointing this out.

#3 - 2015-04-23 08:51 - Toshi MARUYAMA

- Related to Defect #19482: Custom field (long text format) displayed even if empty added
